const dbSAPPS = require("../../helpers/db");
require("dotenv").config();
const { Op } = require("sequelize");

module.exports = {
	create,
	getAll,
	option,
	count,
	update,
	enabled,
	delete: _delete,
};

/**
 * Format an array of bloodGroups by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} bloodGroups - The array of bloodGroups to format.
 * @returns {Promise<Object[]>} - The formatted array of bloodGroups.
 */
const formatWithModifier = async (bloodGroups) => {
	return Promise.all(
		bloodGroups.map(async (bloodGroup) => {
			const modifier = await dbSAPPS.User.findOne({
				where: {
					id: bloodGroup.modified_by,
				},
				attributes: ["full_name"],
			});

			return {
				...bloodGroup,
				modifier: modifier?.full_name,
			};
		})
	);
};

/**
 * Get all bloodGroups with their respective companies.
 * @param {Object} params - An object that contains parameters to filter the bloodGroups.
 * @param {Array} params.companiesId - Array of company IDs to filter by.
 * @returns {Promise<Object>} Resolves with an object that contains the bloodGroups and a success flag.
 * @example
 * const result = await getAll({ companiesId: [1, 2] });
 * console.log(result);
 */
async function getAll(params) {
	try {
		// filter
		const filterConditions = {};

		if (params.companiesId) {
			filterConditions.company_id = {
				[Op.in]: params.companiesId,
			};
		}

		let bloodGroups = [];
		bloodGroups = await dbSAPPS.BloodGroup.findAll({
			where: filterConditions,
			order: [["modified", "DESC"]],
			include: [
				{
					model: dbSAPPS.Company,
					as: "company",
					attributes: ["id", "display_name"],
				},
			],
		});

		bloodGroups = bloodGroups.map((bloodGroup) => {
			return {
				...bloodGroup.dataValues,
				company_name: bloodGroup?.company?.display_name,
			};
		});

		bloodGroups = await formatWithModifier(bloodGroups);

		return {
			bloodGroups,
			success: true,
			message: "Loaded successfully!",
		};
	} catch (error) {
		const errorMessage = error?.message || "Failed to load, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Get bloodGroups with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the bloodGroups.
 * @param {Array} params.companiesId - Array of company IDs to filter by.
 * @returns {Promise<Object>} Resolves with an object that contains the bloodGroups and a success flag.
 * @example
 * const result = await option({ companiesId: [1, 2] });
 * console.log(result);
 */
async function option(params) {
	try {
		// filter
		const filterConditions = {};

		if (params.company_id) {
			filterConditions.company_id = {
				[Op.eq]: params.company_id,
			};
		}

		if (params.companiesId) {
			filterConditions.company_id = {
				[Op.in]: params.companiesId,
			};
		}

		// must be enabled
		filterConditions.enabled = {
			[Op.eq]: true,
		};

		let options = [];
		options = await dbSAPPS.BloodGroup.findAll({
			where: filterConditions,
			attributes: ["id", "name", "display_name"],
			include: [
				{
					model: dbSAPPS.Company,
					as: "company",
					attributes: ["id", "name", "display_name"],
				},
			],
			order: [["name", "ASC"]],
		});

		options = options.map((option) => {
			return {
				...option.dataValues,
				company_name: option?.company?.display_name,
			};
		});

		return {
			options,
			success: true,
			message: "Loaded successfully!",
		};
	} catch (error) {
		const errorMessage = error?.message || "Failed to load, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Count active bloodGroups
 *
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>}
 */
async function count(params) {
	try {
		// filter
		const filterConditions = {};

		// must be enabled
		filterConditions.enabled = {
			[Op.eq]: true,
		};

		const count = await dbSAPPS.BloodGroup.count({
			where: filterConditions,
		});

		return {
			count,
			success: true,
			message: "Loaded successfully!",
		};
	} catch (error) {
		const errorMessage = error?.message || "Failed to load, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Creates a new bloodGroup
 *
 * @param {object} params - bloodGroup data to be created.
 * @param {string} params.name - bloodGroup name.
 * @param {string} params.display_name - bloodGroup display name.
 * @param {boolean} [params.enabled=true] - bloodGroup enabled status.
 * @param {number} [params.creation=Date.now()] - bloodGroup creation timestamp.
 * @param {number} [params.modified=Date.now()] - bloodGroup last modification timestamp.
 * @param {number} [params.owner=1] - User ID of the bloodGroup owner.
 * @param {number} [params.modified_by=1] - User ID of the last modifier of the bloodGroup.
 *
 * @returns {Promise<{success: boolean, message: string}>} Result of the bloodGroup creation process.
 */
async function create(params) {
	const transaction = await dbSAPPS.sequelize.transaction();
	try {
		// validate existing
		const existingName = await dbSAPPS.BloodGroup.findOne({
			where: { name: params.name, company_id: params.company_id },
			transaction,
		});
		if (existingName) {
			return {
				success: false,
				message: `"${params.name}" is already taken.`,
			};
		}

		const existingDisplayName = await dbSAPPS.BloodGroup.findOne({
			where: {
				display_name: params.display_name,
				company_id: params.company_id,
			},
			transaction,
		});
		if (existingDisplayName) {
			return {
				success: false,
				message: `"${params.display_name}" is already taken.`,
			};
		}

		// save
		await dbSAPPS.BloodGroup.create(params, { transaction });

		await transaction.commit();
		return {
			success: true,
			message: "Saved successfully!",
		};
	} catch (error) {
		await transaction.rollback();
		const errorMessage = error?.message || "Failed to save, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Updates an existing bloodGroup
 *
 * @param {number} id - bloodGroup ID to be updated.
 * @param {object} params - bloodGroup data to be updated.
 * @param {string} [params.name] - bloodGroup name.
 * @param {string} [params.display_name] - bloodGroup display name.
 * @param {boolean} [params.enabled] - bloodGroup enabled status.
 * @param {number} [params.creation] - bloodGroup creation timestamp.
 * @param {number} [params.modified] - bloodGroup last modification timestamp.
 * @param {number} [params.owner] - User ID of the bloodGroup owner.
 * @param {number} [params.modified_by] - User ID of the last modifier of the bloodGroup.
 *
 * @returns {Promise<{success: boolean, message: string}>} Result of the bloodGroup update process.
 */
async function update(id, params) {
	const transaction = await dbSAPPS.sequelize.transaction();
	try {
		// validate existing
		const bloodGroup = await dbSAPPS.BloodGroup.findByPk(id);
		if (!bloodGroup) return { success: false, message: "ID not found!" };

		// validate existing
		const existingName = await dbSAPPS.BloodGroup.findOne({
			where: {
				name: params.name,
				company_id: params.company_id,
				id: {
					[Op.ne]: id,
				},
			},
			transaction,
		});
		if (existingName) {
			return {
				success: false,
				message: `"${params.name}" is already taken.`,
			};
		}

		const existingDisplayName = await dbSAPPS.BloodGroup.findOne({
			where: {
				display_name: params.display_name,
				company_id: params.company_id,
				id: {
					[Op.ne]: id,
				},
			},
			transaction,
		});
		if (existingDisplayName) {
			return {
				success: false,
				message: `"${params.display_name}" is already taken.`,
			};
		}

		// save
		await bloodGroup.update(params, { transaction });

		await transaction.commit();
		return {
			success: true,
			message: "Saved successfully!",
		};
	} catch (error) {
		await transaction.rollback();
		const errorMessage = error?.message || "Failed to save, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Enable or disable a bloodGroup
 * @param {number} id - the id of the bloodGroup
 * @param {object} params - the update data
 * @param {boolean} params.enabled - the enabled status of the bloodGroup
 * @param {number} [params.modified_by] - the modified by of the bloodGroup
 * @param {Date} [params.modified] - the modified of the bloodGroup
 * @returns {Promise<object>} - the result of the update
 */
async function enabled(id, params) {
	const transaction = await dbSAPPS.sequelize.transaction();
	try {
		// validate existing
		const bloodGroup = await dbSAPPS.BloodGroup.findByPk(id);
		if (!bloodGroup) return { success: false, message: "ID not found!" };

		// update params
		const updateData = {};
		updateData.enabled = params.enabled;
		if (params.modified_by) updateData.modified_by = params.modified_by;
		if (params.modified) updateData.modified = params.modified;

		// save
		await bloodGroup.update(updateData, { transaction });

		await transaction.commit();
		return {
			success: true,
			message: "Saved successfully!",
		};
	} catch (error) {
		await transaction.rollback();
		const errorMessage = error?.message || "Failed to save, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}

/**
 * Delete a bloodGroup
 * @param {number} id - the id of the bloodGroup
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
	const transaction = await dbSAPPS.sequelize.transaction();
	try {
		// validate existing
		const bloodGroup = await dbSAPPS.BloodGroup.findByPk(id, { transaction });
		if (!bloodGroup) return { success: false, message: "ID not found!" };

		// delete
		await bloodGroup.destroy({ transaction });

		await transaction.commit();
		return {
			success: true,
			message: "Deleted successfully!",
		};
	} catch (error) {
		await transaction.rollback();
		const errorMessage =
			error?.message || "Failed to delete, please try again!";
		return {
			success: false,
			message: errorMessage,
		};
	}
}
